<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns="http://purl.oclc.org/dsdl/schematron"
   queryBinding="xslt2">
<title>Sample: Value X is equal to some value Y 12/07</title>

  <pattern>
    
    <rule context="mediaobject">
      <assert test="caption">mediaobject must have a caption</assert>
      <assert test="imageobject or textobject">mediaobject must have either an imageobject or textobject</assert>
      <assert test="not(imageobject and textobject)">mediaobject may not mix imageobject and textobject together</assert>
      <report test="*[not(self::caption|self::imageobject|self::textobject)]">mediaobject contains elements other than caption, imageobject or textobject</report>
    </rule>    
    
    <rule context="mediaobject/caption">
      <report test="preceding-sibling::*">caption must be the first element inside mediaobject</report>
    </rule>
    
  </pattern>

</schema>