<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns="http://purl.oclc.org/dsdl/schematron" queryBinding="xslt2" >
<title>Sample: A More Realistic Example (requires XPath 2.0)</title>
 
  <ns prefix="xs" uri="http://www.w3.org/2001/XMLSchema"/>
  
  <!-- Uses XPath 2.0 and XML Schema datatypes to do some fancy checking -->

  <pattern id="uri-testing">
    <rule context="imagedata">
      <assert test="normalize-space(@fileref)">@fileref isn't given</assert>
      <assert test="@fileref castable as xs:anyURI">broken URI in @fileref</assert>
    </rule>
    <rule context="ulink">
      <assert test="normalize-space(@url)">ulink/@url isn't given</assert>
      <assert test="@url castable as xs:anyURI">broken URI in ulink/@url</assert>
    </rule>
  </pattern>
  
  <pattern id="codeblock-testing">
    <rule context="programlisting">
      <assert test="every $line in tokenize(.,'&#xA;') satisfies string-length($line) le 72">programlisting is wider than 72 characters</assert> 
    </rule>
  </pattern>

</schema>