<?xml version="1.0" encoding="UTF-8"?>
<schema xmlns="http://purl.oclc.org/dsdl/schematron"
   queryBinding="xslt2">
<title>Attributes Using an Abstract Pattern</title>

  <pattern id="non-ws-attribute" abstract="true">
    <rule context="$element">
      <assert test="normalize-space($attribute)"><name/> has no <value-of select="local-name($attribute)"/> given</assert>
    </rule>
  </pattern>

  
  <pattern id="ulink-url" is-a="non-ws-attribute">
    <param name="element" value="ulink"/>
    <param name="attribute" value="@url"/>
  </pattern>
  
  <pattern id="imagedata-fileref" is-a="non-ws-attribute">
    <param name="element" value="imagedata"/>
    <param name="attribute" value="@fileref"/>
  </pattern>

</schema>