<?xml version="1.0" encoding="UTF-8"?>
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron"
   queryBinding="xslt2">
<sch:title>Uses XPath 2.0 and XML Schema datatypes to check on
       proper syntax of our URIs </sch:title>
 
  <sch:ns prefix="xs" uri="http://www.w3.org/2001/XMLSchema" />
  
  <sch:pattern>

    <sch:rule context="imagedata">
      <sch:assert test="normalize-space(@fileref)">@fileref isn't given</sch:assert>
      <sch:assert test="@fileref castable as xs:anyURI">broken URI in @fileref</sch:assert>
    </sch:rule>

    <sch:rule context="ulink">
      <sch:assert test="normalize-space(@url)">ulink/@url isn't given</sch:assert>
      <sch:assert test="@url castable as xs:anyURI">broken URI in ulink/@url</sch:assert>
    </sch:rule>

  </sch:pattern>

</sch:schema>